let make = (~path, ~headers=?, ~body, ()) =>
  Vow.Result.wrap(
    Fetch.(
      fetchWithInit(
        Constants.apiHost ++ path,
        RequestInit.make(
          ~method_=Post,
          ~credentials=Include,
          ~headers=
            HeadersInit.make(
              switch headers {
              | Some(headers) => headers
              | None => {
                  "Content-Type": "application/json",
                  "Accepts": "application/json"
                }
              }
            ),
          ~body=BodyInit.make(body),
          ()
        )
      )
    ),
    _err =>
    BsLibrarian.ErrorModel.Error
  )
  |> Vow.Result.flatMap(response =>
       Vow.Result.wrap(Fetch.Response.json(response), _err =>
         BsLibrarian.ErrorModel.Error
       )
     );