module Params = {
  type t = {cursor: option(string)};
  let make = (~cursor=None, ()) => {cursor: cursor};
  let encode = model =>
    switch model.cursor {
    | Some(cursor) => Json.Encode.(object_([("cursor", string(cursor))]))
    | None => Json.Encode.object_([])
    };
};

let request = (~fileSource, params) =>
  Request.(
    make(
      ~path=
        FilesListModel.File.(
          switch fileSource {
          | Dropbox => "/dropbox/files"
          | GoogleDrive => "/drive/files"
          }
        ),
      ~body=params |> Params.encode |> Js.Json.stringify,
      ()
    )
  )
  |> Vow.Result.flatMap(ResponseModel.decode(FilesListModel.decode));

let dropbox = request(~fileSource=FilesListModel.File.Dropbox);

let googleDrive = request(~fileSource=FilesListModel.File.GoogleDrive);