open Utils;

let request = (~url, ~signingParams: SignService.Params.t, data) =>
  Vow.Result.wrap(
    Fetch.(
      fetchWithInit(
        url,
        RequestInit.make(
          ~method_=
            SignService.(
              switch signingParams.method {
              | Params.Put => Put
              | Params.Get => Get
              }
            ),
          ~headers=
            HeadersInit.make({"Content-Type": signingParams.contentType}),
          ~body=data |> toFetchBlob |> BodyInit.makeWithBlob,
          ()
        )
      )
    ),
    _err =>
    BsLibrarian.ErrorModel.Error
  );